# %%
%matplotlib qt
import os
import csv
import shutil

from copy import deepcopy
from bagpy import bagreader
import matplotlib.pyplot as plt
from matplotlib import ticker as tck
from matplotlib import rcParams
import numpy as np
from scipy import signal

from pynocchio import RobotWrapper
from pinocchio import SE3, Quaternion, log6

# %% MACROS

bag_directory = "."
bag_init_name = "exp_23_06_28_initialisation_2023-06-28-16-03-42.bag" 
bag_exp_name = "exp_23_06_28_exp_2kg_weight_2023-06-28-16-05-00.bag" 
bag_exp_tau_name = "config_neutral_21N_z_2023-08-11-11-03-38.bag" #"config_neutral_20N_z_2023-08-07-10-57-29.bag"

init_topics = ["joint_states", 
               "netft_data"]
exp_topics = ["joint_states", 
               "netft_data",
               "desired_cartesian_pose"]
exp_tau_topics = ["joint_states", 
               "external_force",
               "desired_cartesian_pose"]

g = 9.81

# %% FUNCTIONS

def get_data_from_rosbag(bag_name, topics, verbose=False):
    bag_file = bagreader(bag_name, verbose=verbose)
    topic_list = [*bag_file.topics]
    # indexes of the desired topics in the actual topic list
    idxs = [i for des_topic in topics for i, topic in enumerate(topic_list) if des_topic in topic]
    csv_names = [bag_file.message_by_topic(topic_list[idx]) for idx in idxs]
    raw_data = [np.genfromtxt( ("\t".join(i) for i in csv.reader(open(csv_name))), delimiter="\t", names=True ) for csv_name in csv_names]
    # the message_by_topic function creates csv files inside the folder generated by the bagreader, we delete them after getting the data 
    shutil.rmtree(os.path.dirname(csv_names[0])) 
    return dict(zip(topics, raw_data))

def get_ft_data(raw_ft_data):
    headers = raw_ft_data.dtype.names
    time_idx = [i for i, header in enumerate(headers) if header.lower() == 'time'][0]
    force_idx = [i for i, header in enumerate(headers) for force_name in ['wrenchforcex', 'wrenchforcey', 'wrenchforcez'] if header.lower() == force_name]
    torque_idx = [i for i, header in enumerate(headers) for torque_name in ['wrenchtorquex', 'wrenchtorquey', 'wrenchtorquez'] if header.lower() == torque_name]
    
    raw_time = np.array([np.array(data.tolist())[time_idx] for data in raw_ft_data]).T
    raw_force = np.array([np.array(data.tolist())[force_idx] for data in raw_ft_data]).T
    raw_torque = np.array([np.array(data.tolist())[torque_idx] for data in raw_ft_data]).T

    return dict(zip(['t', 'f_ext', 'tau_ext'], [raw_time, raw_force, raw_torque]))

def get_joint_data(raw_joint_data, nb_joints):
    headers = raw_joint_data.dtype.names
    time_idx = [i for i, header in enumerate(headers) if header.lower() == 'time'][0]
    q_idx = [i for i, header in enumerate(headers) for joint_position_name in ['position_' + str(i) for i in range(nb_joints+1)] if header.lower() == joint_position_name]
    dq_idx = [i for i, header in enumerate(headers) for joint_velocity_name in ['velocity_' + str(i) for i in range(nb_joints+1)] if header.lower() == joint_velocity_name]
    tau_idx = [i for i, header in enumerate(headers) for joint_effort_name in ['effort_' + str(i) for i in range(nb_joints+1)] if header.lower() == joint_effort_name]
    
    raw_time = np.array([np.array(data.tolist())[time_idx] for data in raw_joint_data]).T
    raw_q = np.array([np.array(data.tolist())[q_idx] for data in raw_joint_data]).T
    raw_dq = np.array([np.array(data.tolist())[dq_idx] for data in raw_joint_data]).T
    raw_tau = np.array([np.array(data.tolist())[tau_idx] for data in raw_joint_data]).T

    return dict(zip(['t', 'q', 'dq', 'tau'], [raw_time, raw_q, raw_dq, raw_tau]))

def get_desired_pose(raw_desired_pose_data):
    headers = raw_desired_pose_data.dtype.names
    time_idx = [i for i, header in enumerate(headers) if header.lower() == 'time'][0]
    position_idx = [i for i, header in enumerate(headers) for position_name in ['posepositionx', 'posepositiony', 'posepositionz'] if header.lower() == position_name]
    orientation_idx = [i for i, header in enumerate(headers) for quaternion_name in ['poseorientationx', 'poseorientationy', 'poseorientationz', 'poseorientationw'] if header.lower() == quaternion_name]
    
    raw_time = np.array([np.array(data.tolist())[time_idx] for data in raw_desired_pose_data]).T
    raw_position = np.array([np.array(data.tolist())[position_idx] for data in raw_desired_pose_data]).T
    raw_orientation = np.array([np.array(data.tolist())[orientation_idx] for data in raw_desired_pose_data]).T

    return dict(zip(['t', 'des_position', 'des_orientation'], [raw_time, raw_position, raw_orientation]))

def interpolate(extracted_data, step, ):
    # building time array
    max_t0 = -np.inf
    min_tend = np.inf
    for data in extracted_data.values():
        if max_t0 < data['t'][0]:
            max_t0 = data['t'][0]
        if min_tend > data['t'][-1]:
            min_tend = data['t'][-1]
    t = np.arange(max_t0, min_tend, step)
    # interpolating data on the built time array
    interp_data = {}
    for topic, data in extracted_data.items():
        if "joint_states" in topic:
            q = np.array([np.interp(t, data['t'], qi) for qi in data['q']])
            dq = np.array([np.interp(t, data['t'], dqi) for dqi in data['dq']])
            tau = np.array([np.interp(t, data['t'], taui) for taui in data['tau']])
            interp_data[topic] = dict(zip(['q', 'dq', 'tau'], [q, dq, tau]))
        elif  "netft_data" in topic or "external_force" in topic:
            force = np.array([np.interp(t, data['t'], fi) for fi in data['f_ext']])
            torque = np.array([np.interp(t, data['t'], tqi) for tqi in data['tau_ext']])
            interp_data[topic] = dict(zip(['f_ext', 'tau_ext'], [force, torque]))
        elif  "desired_cartesian_pose" in topic:
            position = np.array([np.interp(t, data['t'], fi) for fi in data['des_position']])
            orientation = np.array([np.interp(t, data['t'], tqi) for tqi in data['des_orientation']])
            interp_data[topic] = dict(zip(['des_position', 'des_orientation'], [position, orientation]))

    t = t - t[0]
    for topic in extracted_data.keys():
        interp_data[topic]['t'] = t

    return interp_data

def compute_ft_biases_and_mass(bias_data, robot_wrapper, do_gravity_compensation=True):
    '''
    This function can only work if the forces were measured in the absence of applied external forces. The forces from acceleration phenomenon are neglected.
    '''
    # get joint data
    # joint_states_key = [key for key in bias_data.keys() if 'joint_states' in key][0]
    # q = bias_data[joint_states_key]['q']
    q = bias_data['q']
    if q.shape[1] == robot_wrapper.n: # TODO, this might fails if the number of samples is equal to the number of joints
        q = q.T
    # get bias force data
    # ft_key = [key for key in bias_data.keys() if 'netft_data' in key][0]
    # force = bias_data[ft_key]['force']
    # torque = bias_data[ft_key]['torque']
    force = bias_data['f_ext']
    torque = bias_data['tau_ext']
    if force.shape[1] == 3: 
        force = force.T
    if torque.shape[1] == 3: 
        torque = torque.T
    # compute the static acceleration projection seen by the sensor
    s_a = np.array([0, 0, -g])
    s_a_projection = [] # depends on the robot configuration
    for qi in q.T:
        Rend_0 = robot_wrapper.forward(qi).rotation.T
        s_a_projection.append(Rend_0 @ s_a)
    s_a_projection = np.array(s_a_projection)
    # f_end_end_meas = R_end_0 * m * g + f_bias + f_end_end_ext (without physical interaction, f_end_end_ext=0)
    # phi = [eye(3), R_end_0 * g], xi = [f_bias_x; f_bias_y; f_bias_z; m]
    # least square: xi = (phi^t * phi)^(-1) * phi^t * f_end_end_meas 
    phi = np.concatenate((np.eye(3), np.zeros((3,1))), axis=1)
    phi = np.tile(phi, (force.shape[1], 1))
    phi[:,3] = s_a_projection.flatten()
    # 
    y = force.T.flatten()
    xi = np.linalg.inv(phi.T @ phi) @ phi.T @ y
    # 
    # unbiased_force = force - xi[0:3].reshape(3,1)
    # if do_gravity_compensation:
    #     grav_compensation = xi[3] * s_a_projection.T
    #     unbiased_force = unbiased_force - grav_compensation
    # # TODO: compute arm lever, here it is neglected

    # bias_data[ft_key]['force'] = unbiased_force
    # # bias_data[ft_key]['torque'] = unbiased_torque

    # returns [bx, by, bz], m
    return xi[0:3], xi[3]

def unbiased_ft_data(bias_data, robot_wrapper, mass, nb_calibration_samples=1000):
    '''
    The bias are computed using the first x samples of the force sensor, then the data is unbiased
    Returns unbiased forces (todo:) and torques, and biases estimated
    '''
    # get joint data
    # joint_states_key = [key for key in bias_data.keys() if 'joint_states' in key][0]
    # q = bias_data[joint_states_key]['q']
    q = bias_data['q']
    if q.shape[1] == robot_wrapper.n: # TODO, this might fails if the number of samples is equal to the number of joints
        q = q.T
    # get bias force data
    # ft_key = [key for key in bias_data.keys() if 'netft_data' in key][0]
    # force = bias_data[ft_key]['force']
    # torque = bias_data[ft_key]['torque']
    force = bias_data['f_ext']
    torque = bias_data['tau_ext']
    if force.shape[1] == 3: 
        force = force.T
    if torque.shape[1] == 3: 
        torque = torque.T
    # compute the projected weight in the sensor frame
    weight = np.array([0, 0, -mass*9.81])
    weight_projection = [] # depends on the robot configuration
    for qi in q.T:
        Rend_0 = robot_wrapper.forward(qi).rotation.T
        weight_projection.append(Rend_0 @ weight)
    weight_projection = np.array(weight_projection).T
    # weight compensation
    force = force - weight_projection
    # computing the biases
    biases = np.mean(force[:,0:nb_calibration_samples], axis=1).reshape(3,1)
    #
    unbiased_force = force - biases
    unbias_data = deepcopy(bias_data)
    unbias_data['f_ext'] = unbiased_force
    # TODO unbias torques
    return unbias_data, biases

def set_force_to_base_frame(data, robot_wrapper):
    '''
    Change the sensor data from the sensor frame to the base frame
    '''
    # get joint data
    # joint_states_key = [key for key in data.keys() if 'joint_states' in key][0]
    # q = data[joint_states_key]['q']
    q = data['q']
    if q.shape[1] == robot_wrapper.n: # TODO, this might fails if the number of samples is equal to the number of joints
        q = q.T
    # get bias force data
    # ft_key = [key for key in data.keys() if 'netft_data' in key][0]
    # force = data[ft_key]['force']
    # torque = data[ft_key]['torque']
    force = data['f_ext']
    torque = data['tau_ext']
    if force.shape[1] == 3: 
        force = force.T
    if torque.shape[1] == 3: 
        torque = torque.T
    # compute the force data in the base frame
    force_in_base = []
    torque_in_base = []
    for qi, fi, taui in zip(q.T, force.T, torque.T):
        R0_end = robot_wrapper.forward(qi).rotation
        force_in_base.append(R0_end @ fi)
        torque_in_base.append(R0_end @ taui)
    force_in_base = np.array(force_in_base).T
    torque_in_base = np.array(torque_in_base).T
    #
    data['f_ext_b'] = force_in_base
    data['tau_ext_b'] = torque_in_base
    return data

def set_force_from_env_to_robot(data):
    '''
    The force sensor returns the reaction force, for the computation the force from the env point of view is required
    '''
    data['f_ext'] = -data['f_ext']
    data['tau_ext'] = -data['tau_ext']

def compute_servoing_error(data):
    '''
    Compute the servoing error between a desired pose and an actual pose in SE3
    '''
    servoing_error = []
    for pose_i, desired_pose_i in zip(data['pose'], data['desired_pose']):
        adj = np.concatenate( (np.concatenate( (pose_i.rotation, np.zeros((3,3))), axis=1 ),np.concatenate( (np.zeros((3,3)), pose_i.rotation), axis=1 )), axis=0 )
        servoing_error.append( adj @ log6(pose_i.actInv(desired_pose_i)).vector )
    servoing_error = np.array(servoing_error).T
    new_data = deepcopy(data)
    new_data['serv_err'] = servoing_error
    return new_data

def compute_static_error(data, robot_wrapper, KP):
    '''
    Compute the estimated static error, based on the robot model and control, and input force
    '''
    estimated_pose_deviation = []
    for qi, fi, taui in zip(data['q'].T, data['f_ext_b'].T, data['tau_ext_b'].T):
        J = robot_wrapper.jacobian(qi)
        estimated_pose_deviation.append(np.linalg.inv(KP) @ J @ np.linalg.inv(robot_wrapper.mass_matrix(qi)) @ J.T @ np.hstack((fi,taui)))
    estimated_pose_deviation = np.array(estimated_pose_deviation).T

    new_data = deepcopy(data)
    new_data['est_pose_deviation'] = estimated_pose_deviation
    return new_data

def filter(data, var_name_list, fc=50, order=4):
    '''
    Low pass digital filter with cutoff frequency fc
    '''
    fs = 1/np.mean(np.diff(data['t'])) # sampling frequency
    w = fc / (fs / 2) # normalized frequency
    b, a = signal.butter(order, w, 'low')
    data_filt = deepcopy(data)
    for var_name in var_name_list:
        data_filt[var_name] = signal.filtfilt(b, a, data[var_name])
    
    return data_filt

# %% MAIN
# this initialization phase allows to estimate the mass seen by the force torque sensor
data_init = get_data_from_rosbag(bag_init_name, init_topics)
raw_joint_data = get_joint_data(data_init[init_topics[0]], nb_joints=7)
raw_ft_data = get_ft_data(data_init[init_topics[1]])

data_interpolated = interpolate({init_topics[0]: raw_joint_data, init_topics[1]: raw_ft_data}, 1e-3)
merged_data = {**data_interpolated[init_topics[0]], **data_interpolated[init_topics[1]]}

panda = RobotWrapper(urdf_path="panda.urdf")
biases, m = compute_ft_biases_and_mass(merged_data, panda)

del data_init, raw_joint_data, raw_ft_data, data_interpolated

# %% get experimental data (with weight)
data_exp = get_data_from_rosbag(bag_exp_name, exp_topics)
raw_joint_exp_data = get_joint_data(data_exp[exp_topics[0]], nb_joints=7)
raw_ft_exp_data = get_ft_data(data_exp[exp_topics[1]])
raw_desired_pose_data = get_desired_pose(data_exp[exp_topics[2]])

exp_data_interpolated = interpolate({exp_topics[0]: raw_joint_exp_data, exp_topics[1]: raw_ft_exp_data, exp_topics[2]: raw_desired_pose_data} , 1e-3)
merged_data = {**exp_data_interpolated[exp_topics[0]], **exp_data_interpolated[exp_topics[1]], **exp_data_interpolated[exp_topics[2]]}

exp_data_unbiased, biases = unbiased_ft_data(merged_data, panda, mass=m)
set_force_from_env_to_robot(exp_data_unbiased)
set_force_from_env_to_robot(merged_data)

# %% get experimental data (with torques)
data_exp_tau = get_data_from_rosbag(bag_exp_tau_name, exp_tau_topics)
raw_joint_exp_tau_data = get_joint_data(data_exp_tau[exp_tau_topics[0]], nb_joints=7)
raw_ft_exp_tau_data = get_ft_data(data_exp_tau[exp_tau_topics[1]])
raw_desired_pose_exp_tau_data = get_desired_pose(data_exp_tau[exp_tau_topics[2]])

# add fake data before and after perturbation for proper interpolation
raw_ft_exp_tau_data['t'] = np.r_[raw_joint_exp_tau_data['t'][0], raw_ft_exp_tau_data['t'], raw_joint_exp_tau_data['t'][-1]]
raw_ft_exp_tau_data['f_ext'] = np.hstack(( np.zeros((3,1)), raw_ft_exp_tau_data['f_ext'], np.zeros((3,1)) ))
raw_ft_exp_tau_data['tau_ext'] = np.hstack(( np.zeros((3,1)), raw_ft_exp_tau_data['tau_ext'], np.zeros((3,1)) ))

exp_tau_data_interpolated = interpolate({exp_tau_topics[0]: raw_joint_exp_tau_data, exp_tau_topics[1]: raw_ft_exp_tau_data, exp_tau_topics[2]: raw_desired_pose_exp_tau_data} , 1e-3)
merged_data_tau = {**exp_tau_data_interpolated[exp_tau_topics[0]], **exp_tau_data_interpolated[exp_tau_topics[1]], **exp_tau_data_interpolated[exp_tau_topics[2]]}
# the force torque data does not need to be unbiaised or change from env to robot here
merged_data_tau['f_ext_b'] = merged_data_tau['f_ext']
merged_data_tau['tau_ext_b'] = merged_data_tau['tau_ext']

# %% display the force sensor data with gravity compensation and unbiasing
color_list = ['tab:blue', 'tab:orange', 'tab:green']
fig, axs = plt.subplots(1,3,sharex=True)
plt.rcParams.update({'font.size': 16})
for i, (fi, fi_unbiased) in enumerate(zip(merged_data['f_ext'], exp_data_unbiased['f_ext'])):
    axs[i].plot(merged_data['t'], fi, color=color_list[0], linewidth=2)
    axs[i].plot(exp_data_unbiased['t'], fi_unbiased, color=color_list[1], linewidth=2)

# %%
merged_data = set_force_to_base_frame(merged_data, panda)
exp_data_unbiased = set_force_to_base_frame(exp_data_unbiased, panda)
exp_data_unbiased_filtered = filter(exp_data_unbiased, ['f_ext', 'tau_ext', 'f_ext_b'], fc=15, order=4)

# %% display the force sensor data in the base frame
fig, axs = plt.subplots(1,3,sharex=True)
plt.rcParams.update({'font.size': 11})
for i, (fi, fi_unbiased, fi_unbiased_filt) in enumerate(zip(merged_data['f_ext_b'], exp_data_unbiased['f_ext_b'], exp_data_unbiased_filtered['f_ext_b'])):
    axs[i].plot(merged_data['t'], fi, color=color_list[0], linewidth=2)
    axs[i].plot(exp_data_unbiased['t'], fi_unbiased, color=color_list[1], linewidth=2)
    axs[i].plot(exp_data_unbiased_filtered['t'], fi_unbiased_filt, color=color_list[2], linewidth=1)
fig.suptitle('Experimental force from the weight data experiment in the base frame')

fig, axs = plt.subplots(1,3,sharex=True)
plt.rcParams.update({'font.size': 11})
for i, fi in enumerate(merged_data_tau['f_ext']):
    axs[i].plot(merged_data_tau['t'], fi, color=color_list[0], linewidth=2)
fig.suptitle('Experimental force from the torque data experiment in the base frame')

# %%
# compute SE3 poses
pose = [SE3(panda.forward(data)) for data in exp_data_unbiased_filtered['q'].T]
desired_pose = [SE3(Quaternion(np.array(wi)).toRotationMatrix(), np.array(ti)) for ti, wi in zip(exp_data_unbiased['des_position'].T, exp_data_unbiased['des_orientation'].T)]
exp_data_unbiased_filtered['pose'] = pose
exp_data_unbiased_filtered['desired_pose'] = desired_pose
#
pose = [SE3(panda.forward(data)) for data in merged_data_tau['q'].T]
desired_pose = [SE3(Quaternion(np.array(wi)).toRotationMatrix(), np.array(ti)) for ti, wi in zip(merged_data_tau['des_position'].T, merged_data_tau['des_orientation'].T)]
merged_data_tau['pose'] = pose
merged_data_tau['desired_pose'] = desired_pose

# %% Computing the experimental and theoretical deviations
exp_data_unbiased_filtered = compute_servoing_error(exp_data_unbiased_filtered)
exp_data_unbiased_filtered = compute_static_error(exp_data_unbiased_filtered, panda, 500*np.eye(6))
merged_data_tau = compute_servoing_error(merged_data_tau)
merged_data_tau = compute_static_error(merged_data_tau, panda, 500*np.eye(6))

# %% display
# fig, axs = plt.subplots(1,6,sharex=True)
# plt.rcParams.update({'font.size': 16})
# for i, (meas_err, est_err) in enumerate(zip(exp_data_unbiased_filtered['serv_err'], exp_data_unbiased_filtered['est_pose_deviation'])):
#     axs[i].plot(exp_data_unbiased_filtered['t'], meas_err - meas_err[0], color=color_list[0], linewidth=2)
#     axs[i].plot(exp_data_unbiased_filtered['t'], est_err, color=color_list[1], linewidth=1)

# %%
# force data step starts at 11.9s for the weight experiment, and 3.36 for the tau exp
t_sync = merged_data_tau['t'] + 11.9 - 3.36

# also synchronize the other edge by reducing evenly the static phase
idx_1 = np.where(t_sync>=11.9)[0][0]
idx_2 = np.where(t_sync>=25.654)[0][0]
idx_3 = np.where(t_sync>=27.181)[0][0]
idx_4 = np.where(t_sync>=27.45)[0][0]
idx_len = idx_4-idx_1
idx_over = idx_3-idx_2
serv_err_tmp = merged_data_tau['serv_err'][:,idx_1:idx_4+1]
fake_ext_f_tmp = merged_data_tau['f_ext'][:,idx_1:idx_4+1]
step_size = idx_len / (idx_len - idx_over)
select_serv_err = np.array([serv_err_tmp[:,int(i * step_size)] for i in range(idx_len - idx_over)]).T
select_fake_ext_f = np.array([fake_ext_f_tmp[:,int(i * step_size)] for i in range(idx_len - idx_over)]).T
select_t_syn = t_sync[idx_1:idx_4+1-idx_over]

t_sync_tot = np.hstack(( t_sync[:idx_1+1], select_t_syn, t_sync[idx_4+1:] ))
tau_serv_tot = np.hstack(( merged_data_tau['serv_err'][:,:idx_1+1], select_serv_err, merged_data_tau['serv_err'][:,idx_4:] ))
fake_ext_f_tot = np.hstack(( merged_data_tau['f_ext'][:,:idx_1+1], select_fake_ext_f, merged_data_tau['f_ext'][:,idx_4:] ))

tau_serv_err = np.array([np.interp(exp_data_unbiased_filtered['t'], t_sync_tot, val) for val in tau_serv_tot])
fake_ext_f = np.array([np.interp(exp_data_unbiased_filtered['t'], t_sync_tot, val) for val in fake_ext_f_tot])

# %%
fig, ax = plt.subplots(1)
ax.plot(exp_data_unbiased_filtered['t'], np.linalg.norm(exp_data_unbiased_filtered['serv_err'][:3,:]-exp_data_unbiased_filtered['serv_err'][:3,0].reshape(3,1), axis=0), color=color_list[0], linewidth=2, label='meas')
ax.plot(exp_data_unbiased_filtered['t'], np.linalg.norm(exp_data_unbiased_filtered['est_pose_deviation'][:3,:], axis=0), color=color_list[1], linewidth=2, label='est')
ax.plot(exp_data_unbiased_filtered['t'], np.linalg.norm(tau_serv_err[:3,:]-tau_serv_err[:3,0].reshape(3,1), axis=0), color=color_list[2], linewidth=1, label='meas tau')
ax.legend()
# axs[1].plot(merged_data_tau['t'], np.linalg.norm(merged_data_tau['serv_err'][:3,:]-merged_data_tau['serv_err'][:3,0].reshape(3,1), axis=0), color=color_list[0], linewidth=2, label='meas')
# axs[1].plot(merged_data_tau['t'], np.linalg.norm(merged_data_tau['est_pose_deviation'][:3,:], axis=0), color=color_list[1], linewidth=2, label='est')
# axs[1].legend()
fig, ax = plt.subplots(1)
ax.plot(exp_data_unbiased_filtered['t'], np.linalg.norm(exp_data_unbiased_filtered['f_ext_b'][:3,:], axis=0), color=color_list[0], linewidth=2, label='fext')
ax.plot(exp_data_unbiased_filtered['t'], np.linalg.norm(fake_ext_f, axis=0), color=color_list[2], linewidth=1, label='sim fext')
ax.legend()

# %% save data to csv
t1 = 10.5
t2 = 28
t1_idx = np.where(exp_data_unbiased_filtered['t']>=t1)[0][0]
t2_idx = np.where(exp_data_unbiased_filtered['t']>=t2)[0][0]

t = exp_data_unbiased_filtered['t'][t1_idx:t2_idx]
norm_deviation = np.linalg.norm(exp_data_unbiased_filtered['serv_err'][:3,t1_idx:t2_idx]-exp_data_unbiased_filtered['serv_err'][:3,0].reshape(3,1), axis=0)
norm_pred_deviation = np.linalg.norm(exp_data_unbiased_filtered['est_pose_deviation'][:3,t1_idx:t2_idx], axis=0)
norm_deviation_tau = np.linalg.norm(tau_serv_err[:3,t1_idx:t2_idx]-tau_serv_err[:3,0].reshape(3,1), axis=0)

t_sub = t[::10]
norm_deviation_sub = norm_deviation[::10]
norm_pred_deviation_sub = norm_pred_deviation[::10]
norm_deviation_tau_sub = norm_deviation_tau[::10]

header_csv = "time,deviation,deviation_pred,deviation_torque"
data_csv = np.vstack((t_sub, norm_deviation_sub, norm_pred_deviation_sub, norm_deviation_tau_sub))
# np.savetxt("exp_data_weight.csv", data_csv.T, delimiter=',', header=header_csv, comments='')
# %%
# static phase errors
ts1 = 15
ts2 = 25
ts1_idx = np.where(exp_data_unbiased_filtered['t']>=ts1)[0][0]
ts2_idx = np.where(exp_data_unbiased_filtered['t']>=ts2)[0][0]

norm_deviation_static_mean = np.mean(np.linalg.norm(exp_data_unbiased_filtered['serv_err'][:3,ts1_idx:ts2_idx]-exp_data_unbiased_filtered['serv_err'][:3,0].reshape(3,1), axis=0))
norm_pred_deviation_static_mean = np.mean(np.linalg.norm(exp_data_unbiased_filtered['est_pose_deviation'][:3,ts1_idx:ts2_idx], axis=0))
norm_deviation_tau_static_mean = np.mean(np.linalg.norm(tau_serv_err[:3,ts1_idx:ts2_idx]-tau_serv_err[:3,0].reshape(3,1), axis=0))
norm_deviation_static_std = np.std(np.linalg.norm(exp_data_unbiased_filtered['serv_err'][:3,ts1_idx:ts2_idx]-exp_data_unbiased_filtered['serv_err'][:3,0].reshape(3,1), axis=0))
norm_pred_deviation_static_std = np.std(np.linalg.norm(exp_data_unbiased_filtered['est_pose_deviation'][:3,ts1_idx:ts2_idx], axis=0))
norm_deviation_tau_static_std = np.std(np.linalg.norm(tau_serv_err[:3,ts1_idx:ts2_idx]-tau_serv_err[:3,0].reshape(3,1), axis=0))

print("Static error measured: {:.3f} +/- {:.3f}mm".format(norm_deviation_static_mean*1000, norm_deviation_static_std*1000))
print("Static error estimated: {:.3f} +/- {:.3f}mm".format(norm_pred_deviation_static_mean*1000, norm_pred_deviation_static_std*1000))
print("Static error measured with torque inputs: {:.3f} +/- {:.3f}mm".format(norm_deviation_tau_static_mean*1000, norm_deviation_tau_static_std*1000))

norm_static_tau_error_mean = np.mean(np.linalg.norm(exp_data_unbiased_filtered['serv_err'][:3,ts1_idx:ts2_idx]-exp_data_unbiased_filtered['serv_err'][:3,0].reshape(3,1), axis=0)-np.linalg.norm(tau_serv_err[:3,ts1_idx:ts2_idx]-tau_serv_err[:3,0].reshape(3,1), axis=0))
norm_static_tau_error_std = np.std(np.linalg.norm(exp_data_unbiased_filtered['serv_err'][:3,ts1_idx:ts2_idx]-exp_data_unbiased_filtered['serv_err'][:3,0].reshape(3,1), axis=0)-np.linalg.norm(tau_serv_err[:3,ts1_idx:ts2_idx]-tau_serv_err[:3,0].reshape(3,1), axis=0))
norm_static_pred_error_mean = np.mean(np.linalg.norm(exp_data_unbiased_filtered['serv_err'][:3,ts1_idx:ts2_idx]-exp_data_unbiased_filtered['serv_err'][:3,0].reshape(3,1), axis=0)-np.linalg.norm(exp_data_unbiased_filtered['est_pose_deviation'][:3,ts1_idx:ts2_idx], axis=0))
norm_static_pred_error_std = np.std(np.linalg.norm(exp_data_unbiased_filtered['serv_err'][:3,ts1_idx:ts2_idx]-exp_data_unbiased_filtered['serv_err'][:3,0].reshape(3,1), axis=0)-np.linalg.norm(exp_data_unbiased_filtered['est_pose_deviation'][:3,ts1_idx:ts2_idx], axis=0))
#
print("Static error with tau: {:.3f} +/- {:.3f}mm".format(norm_static_tau_error_mean*1000, norm_static_tau_error_std*1000))
print("Static error with pred: {:.3f} +/- {:.3f}mm".format(norm_static_pred_error_mean*1000, norm_static_pred_error_std*1000))
# %%
